#!/bin/sh
#
# Ty4a IRC Bot (c) 2001, 2002, ChatNet.Org.Ru
#
# Based on Dancer originally written by Bjorn Reese and Daniel Stenberg
# See README file for more information.
#    
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
# 
# $Id: install.sh,v 1.7 2002/12/08 07:37:47 andruxa Exp $
#
################################################################################

installdir=`expr \`pwd\` : '\(.*\)/.*'`"/ty4a"
nickpattern="MyBot[|-|_]"
staticnick="t4"
channel="#russian"
server="irc.dalnet.ru"
realname="Ty4a IRC bot"
usernick="MyNick"
username=`logname`
username=${username:-"ident"}
sitename=`expr \`hostname\` : '[^\.]*\.\(.*\)'`
sitename=${sitename:-"domain.net"}
userhost=$username"@*."$sitename


clear
while :
do

#echo
#echo " "
#echo " MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM"
#echo " 7*************JW****($*****5(**%*****%J*********$"
#echo " W!'''''''''''''#5'''''$(''''*@==,''3='''',MW7=*'''''''''=?"
#echo " WJJJ7,''''(JJJ3MJ''''*?W,''''C3'''',@M*''''7#,''''''''''''M"
#echo " $'''''AM,''''3'''''A,''''M$'''''%('''',!'''''C"
#echo " !'''',W%'''''JMW!''''*MA'''''7MM'''',W?,''''!?W='''''5"
#echo " @,''''7='''''!,''''C7'''''!,''''=%'''''**''''*"
#echo " 3....'#?*............'@W*............'#=.............3"
#echo " (''''M@7('''''''''7JM?7(,''''''''''MW,''''''''''''*@"
#echo " @'''''CJ!*'''''!!$3!!!!!!'''''7$'''''!!!'''''"
#echo " C'''''5W*''''*?MMMMMM7'''''5!'''',?M$'''''J"
#echo " M!''''*#,''''CM''''*#,''''77'''''?"
#echo " #,''''$J'''',@#,''''$3'''',@W!''''="
#echo " J''''*@!''''J''''*@''''M5,''',%"
#echo " M*,,,,#,,,,,J!',,,@,,,,,C=,,,,*?"
#echo " MMMMMMMMMMMMMMMMMMMMMMMMMMMM"
#echo " "
#echo
#echo " NOTE: if something is unclear to you, please refer to online"
#echo "       documentation at http://ty4a.sourceforge.net/doc" 
#    echo
#    echo " Enter installation directory path"
#    echo -n " [$installdir] "
#    read inp
#    installdir=${inp:-$installdir}

dialog --clear --title Configuration \
--inputbox "Enter installation directory path:\nThe default is $installdir" \
8 50 \
2> /tmp/input1.$$$
inp=`cat /tmp/input1.$$$`
installdir=${inp:-$installdir}
#
#    echo
#    echo " Enter your desired bot's nickname"
#    echo -n " [$nickpattern] "
#    read inp
#    nickpattern=${inp:-$nickpattern}

dialog --clear --title Configuration \
--inputbox "Enter your desired bot's nickname:\nDefault: $nickpattern" \
8 50 \
2> /tmp/input2.$$$
inp=`cat /tmp/input2.$$$`
nickpattern=${inp:-$nickpattern}

#
#    echo
#    echo " Enter bot's shortcut nick"
#    echo -n " [$staticnick] "
#    read inp
#    staticnick=${inp:-$staticnick}

dialog --clear --title Configuration \
--inputbox "Enter bot's shortcut nick:\nDefault: $staticnick" \
8 50 \
2> /tmp/input3.$$$
inp=`cat /tmp/input3.$$$`
staticnick=${inp:-$staticnick}

#
#    echo
#    echo " Enter your bot's desired home channel"
#    echo -n " [$channel] "
#    read inp
#    channel=${inp:-$channel}
#    if [ `echo $channel | cut -c1` != "#" ]
#	then channel="#"$channel
#    fi

dialog --clear --title Configuration \
--inputbox "Enter bot's home channel:\nDefault: $channel" \
8 50 \
2> /tmp/input4.$$$
inp=`cat /tmp/input4.$$$`
channel=${inp:-$channel}
if [ `echo $channel | cut -c1` != "#" ]
then channel="#"$channel
fi

#
#    echo
#    echo " Enter IRC server address"
#    echo " The syntax is servername[:port[:password]]"
#    echo -n " [$server] "
#    read inp
#    server=${inp:-$server}

dialog --clear --title Configuration \
--inputbox "Enter IRC server address:\nSyntax: servername[:port[:password]]\nDefault: $server" \
9 50 \
2> /tmp/input5.$$$
inp=`cat /tmp/input5.$$$`
server=${inp:-$server}

#
#    echo
#    echo " Enter the real name the bot is going to use."
#    echo -n " [$realname] "
#    read inp
#    realname=${inp:-$realname}

dialog --clear --title Configuration \
--inputbox "Enter the bot's real name:\nDefault: $realname" \
8 50 \
2> /tmp/input6.$$$
inp=`cat /tmp/input6.$$$`
realname=${inp:-$realname}

#
#    echo
#    echo " Enter your nickname."
#    echo " This will become your registered nick for the bot"
#    echo -n " [$usernick] "
#    read inp
#    usernick=${inp:-$usernick}

dialog --clear --title Configuration \
--inputbox "Enter your nickname:\nDefault: $usernick" \
8 50 \
2> /tmp/input7.$$$
inp=`cat /tmp/input7.$$$`
usernick=${inp:-$usernick}

#
#    echo
#    echo " Enter your IRC hostmask (such as ident@hostname)"
#    echo -n " [$userhost] "
#    read inp
#    userhost=${inp:-$userhost}

dialog --clear --title Configuration \
--inputbox "Enter your IRC hostmask\nExample: ident@hostname.ru:\nDefault: $userhost" \
9 50 \
2> /tmp/input8.$$$
inp=`cat /tmp/input8.$$$`
userhost=${inp:-$userhost}

#
#    echo
#    echo " Please note that your nick and hostmask will be used as the"
#    echo " bot's initial user dababase record in order for it to recognize you"
#    echo
dialog --msgbox "Please, note that your nick and hostname\nwill be used as the bot's initial user database\nrecord in order for it to recognize you." \
7 55
#
#    echo "Install directory | $installdir"
#    echo "Nick pattern      | $nickpattern"
#    echo "Shortcut nick     | $staticnick"
#    echo "Channel name      | $channel"
#    echo "Server name       | $server"
#    echo "Real name         | $realname"
#    echo "Your nick         | $usernick"
#    echo "Your hostmask     | $userhost"
#  
#  echo
#  echo "Is this information correct? [y/N] "
#  cont=n
#  read cont
#
#  if [ "$cont" = "y" ]
#    then break
#  fi

if dialog --title Confirmation --yesno "Is the information correct?\n\nInstall directory | $installdir\nNick pattern      | $nickpattern\nShortcut nick     | $staticnick\nChannel name      | $channel\nServer name       | $server\nReal name         | $realname\nYour nick         | $usernick\nYour hostname     | $userhost" 15 55 ; then
break
fi


done

 echo Creating $installdir...
   mkdir $installdir
   mkdir $installdir/script
   
 echo Copying some files...
 
 cp -p ty4a $installdir
 cp -p ./conf/ty4a.whatis $installdir
 cp -p ./script/* $installdir/script/

 echo Making config file...
 ./ty4a config | sed -e "s/^#server =.*/server = $server/g" -e "s/^#nick =.*/nick = $nickpattern/g" -e "s/^#staticnick =.*/staticnick = $staticnick/g" \
 -e "s/^#channel =.*/channel = $channel/g" -e "s/^#name =.*/name = $realname/g" >$installdir/ty4a.conf

# echo Making config file...
# ./ty4a config | sed -e "s/^#server =.*/server = $server/g" -e "s/^#nick =.*/nick = $nickpattern/g" \
# -e "s/^#staticnick =.*/staticnick = $staticnick/g" -e "s/^#channel =.*/channel = $channel/g" \
# -e "s/^#name =.*/name = $realname/g" >$installdir/ty4a.conf


 echo Making launch script...
 cat ./start.sh | sed -e "s:path=.*:path=\"$installdir\":g" >$installdir/start.sh
 chmod u+x $installdir/start.sh

 echo Making initial user database file...
 echo "$usernick 500 (my email)" > $installdir/ty4a.userlist
 echo "!$userhost" >> $installdir/ty4a.userlist
 echo

# echo "Done! You are now ready to run the bot from $installdir!"
# echo "Your initial password is 'changeme', use the LOGIN command to authenticate."
# echo
dialog --clear --msgbox "          Done! You are now ready to run the bot from\n                $installdir\n             Your initial password is 'changeme'.\n            Use the LOGIN command to authenticate." 8 67
