#ifndef SEEN_H
#define SEEN_H

#include "dancer.h"
#include "user.h"

typedef struct Auxstruct {
  struct Auxstruct *link;   /* all nick belonging to the same nick */
  struct Auxstruct *next;   /* for hash table */
  struct Seenstruct *root;
  char *nick;
  long count;
  time_t departure; /* 4.0beta3 entry */
  ulong signature;
} itemaux;

typedef struct Seenstruct {
  struct Seenstruct *link;   /* single-list of all users */
  struct Seenstruct *next;   /* next chained collided hash entry */
  struct Auxstruct *first;   /* head of single list of all nick for this user */
  char *usite;               /* This is the key */
  char *host;                /* This is only used for wildcards */
  time_t departure;
  int type;
  char *by;
  char *msg;
  ulong signature;
} itemseen;

enum seentypes {
  SEENLEAVE = 1, SEENQUIT,     SEENKICK,
  SEENLEFT,      SEENQUITED,   SEENKICKED,
  SEENERROR,     SEENCHANGE
};


bool SeenInit(void);
void SeenCleanup(void);
void Seen(char *, char *);
void SeenNick(char *, char *, char);
void SeenMatch(char *, char *);
void SeenInsert(itemguest *, int, char *, char *);
void SeenInsertAll(int, char *, char *);
void SeenSave(void);
itemaux *SeenMostNick(char *);
itemaux *SeenRecentNick(char *);

#endif /* SEEN_H */
