/************************************************************************
 Ty4a IRC Bot (c) 2001, 2002, ChatNet.Org.Ru

 Based on Dancer originally written by Bjorn Reese and Daniel Stenberg
 See README file for more information.
    
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 
 $Id: setup.h,v 1.1.1.1 2002/11/24 19:54:52 tzapper Exp $

************************************************************************/

#ifndef SETUP_H
#define SETUP_H

struct Config {
  char *label;
  void *value;   /* pointer to the real storage */
  void *def;     /* default value */
  char flags;    /* specifies the kind of config setting, see defines below */
  char setting;  /* value will be saved in setfile */
  char *verbose; /* detailed description of the label */
  bool changed;  /* read from .config or .set file */
};

#define CFG_SWITCH   0 /* TRUE / FALSE */
#define CFG_INTEGER  1 /* 0 - 2G */
#define CFG_STRING   2 /* regular string, pointing to a static string area */
#define CFG_LIST     3 /* comma seperated list, uses itemlist */
#define CFG_FUNCTION 4 /* function */
#define CFG_COMMENT  5 /* Simply prints a comment to config file */

#define BTRUE  (void *)1
#define BFALSE (void *)0


bool ConfigInit(void);
void ConfigCleanup(void);

/******************************************************************************
 * The following piece of source is the new SET functions.
 *****************************************************************************/

struct SetItem {
  char *name;
  long level;   /* if non-zero, different level required to access than for
		   rest of group */
  long flags;   /* see below */
  void *value;  /* pointer to the variable holding the info */
  long ID;      /* for special ones */
  char **help;  /* for localized strings, describe item */
};

#define SET_ONOFF  1 /* just a toggle switch */
#define SET_NUM    2 /* integer */
#define SET_TIME   3 /* contains a time integer */
#define SET_SPEC   4 /* treat special */
#define SET_STRING 5 /* new in 4.7 */

struct SetGroup {
  char *name; /* name of group */
  long level; /* level required to access (if different than 'SET') */
  struct SetItem *group;
  char **help; /* description of the group */
};


int SetSet(char *from, char *line);
int HelpSet(char *from, char *token);
void ShowSetAll(char *from);
void InitSets(void);
void MakeConfig(void);
void ChgCmdLev(char *, char *);

#endif /* SETUP_H */
