/************************************************************************
 Ty4a IRC Bot (c) 2001, 2002, ChatNet.Org.Ru

 Based on Dancer originally written by Bjorn Reese and Daniel Stenberg
 See README file for more information.
    
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 
 $Id: transfer.h,v 1.1.1.1 2002/11/24 19:54:53 tzapper Exp $

************************************************************************/

#ifndef TRANSFER_H
#define TRANSFER_H

#include "dancer.h"
#include "user.h"

/* See logtypes in code */
enum {
  LOG = 0,
  LOGJOIN, LOGPART, LOGQUIT,
  LOGNICK, LOGMODE, LOGKICK,
  LOGCMD, LOGPCMD, LOGMSG,
  LOGCTCP, LOGCLIENT, LOGWARN,
  LOGSPLIT, LOGNJOIN, LOGNHEAL,
  LOGDEBUG, LOGDBUG,
  LOGINIT, LOGPUB,
  LOGKILL, LOGTOPIC,
  LOGNONE /* Must be the last one */
};

#define LOGALLMASK ((1<<LOGNONE)-1)

typedef struct Execstruct {
  struct Header h;
  itemclient *client;  /* non-NULL if dcc chat */
  char *nick;  /* Use nick if no dcc chat (or it has been removed) */
  int socket;
  FILE *pipe;
  bool notify; /* we'd like a file transfer (client) for this nick to get
                  notified when this execution is done */
} itemexec;


itemexec *Execute(char *, char *, ...);
void GotExec(itemexec *);
void Send(char *, char *);
void Sendf(char *, const char *, ...);
void SendMulti(char *, const char *, ...);
inline void SendNick(char *, char *);
void SendNickf(char *, const char *, ...);
void SendCtcp(char *, char *);
void SendCtcpf(char *, const char *, ...);
void ReplyCtcp(char *, char *);
void ReplyCtcpf(char *, const char *, ...);
void MulticastLocal(int, char *);
void MulticastLocalf(int, const char *, ...);
void Multicast(int, char *);
void Multicastf(int, const char *, ...);
void Wall(char *, char *);
void SnoopCommand(char *, char *, char *);
void MessageQueue(void);
void MessageReaper(char *);
void FreeMessage(void *);
void FlushMessages(void);
void Action(char *);
void Actionf(const char *, ...);
void Mode(const char *, ...);
void Kick(char *, char *);
void StickyKick(itemguest *, char *msg);
void Log(int, char *);
void Logf(int, const char *, ...);
void LogInit(void);
void LogSnapshots(void);
void Quit(char *, char *);
void Invite(char *who);
void Debug(const char *, ...);
void Say(char *);

#endif /* TRANSFER_H */
